> For the complete documentation index, see [llms.txt](https://docs.hyperswitch.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hyperswitch.io/integrations/prism/python/payment-method-authentication-service/pre-authenticate.md).

# Pre-authenticate

## Overview

The `pre_authenticate` method initiates the 3D Secure authentication flow. It determines whether frictionless or challenge-based verification is needed.

**Business Use Case:** Before processing a high-value transaction, initiate 3DS to reduce fraud liability.

## Purpose

| Scenario         | Benefit                   |
| ---------------- | ------------------------- |
| Fraud prevention | Shift liability to issuer |
| SCA compliance   | Meet EU requirements      |

## Request Fields

| Field               | Type          | Required | Description                 |
| ------------------- | ------------- | -------- | --------------------------- |
| `merchant_order_id` | str           | Yes      | Your unique order reference |
| `amount`            | Money         | Yes      | Transaction amount          |
| `payment_method`    | PaymentMethod | Yes      | Card details                |
| `return_url`        | str           | Yes      | URL to redirect after 3DS   |

## Response Fields

| Field                      | Type | Description                            |
| -------------------------- | ---- | -------------------------------------- |
| `connector_transaction_id` | str  | Connector's 3DS transaction ID         |
| `status`                   | str  | FRICTIONLESS, AUTHENTICATION\_REQUIRED |
| `authentication_data`      | dict | Device data for next step              |
| `redirection_data`         | dict | Challenge URL if required              |
| `status_code`              | int  | HTTP status code                       |

## Example

### SDK Setup

```python
from hyperswitch_prism import PaymentMethodAuthenticationClient

auth_client = PaymentMethodAuthenticationClient(
    connector='stripe',
    api_key='YOUR_API_KEY',
    environment='SANDBOX'
)
```

### Request

```python
request = {
    "merchant_order_id": "order_001",
    "amount": {
        "minor_amount": 10000,
        "currency": "USD"
    },
    "payment_method": {
        "card": {
            "card_number": {"value": "4242424242424242"},
            "card_exp_month": {"value": "12"},
            "card_exp_year": {"value": "2027"}
        }
    },
    "return_url": "https://your-app.com/3ds/return"
}

response = await auth_client.pre_authenticate(request)
```

### Response

```python
{
    "connector_transaction_id": "pi_3Oxxx...",
    "status": "FRICTIONLESS",
    "authentication_data": {
        "eci": "05",
        "cavv": "AAABBIIFmA=="
    },
    "status_code": 200
}
```

## Next Steps

* [authenticate](/integrations/prism/python/payment-method-authentication-service/authenticate.md) - Complete the 3DS flow


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hyperswitch.io/integrations/prism/python/payment-method-authentication-service/pre-authenticate.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
